//+--------------------------------------------------------------------------+
//|                                                                          |
//|                               zTrace 2.01                                |
//|                                                                          |
//|                      Win32 SDK debugging window DLL                      |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                                                                          |
//|                         Author Patrice TERRIER                           |
//|                                                                          |
//|                         copyright(c) 2009-2013                           |
//|                                                                          |
//|                Patrice Terrier http://www.zapsolution.com                |
//|                                                                          |
//+--------------------------------------------------------------------------+
//|                  Project started on : 04-04-2009 (MM-DD-YYYY)            |
//|                        Last revised : 05-05-2013 (MM-DD-YYYY)            |
//+--------------------------------------------------------------------------+

#include <windows.h>
#include <iostream>
using namespace std;
#include <time.h>

#define ExportC extern "C" _declspec (dllexport)

#define LOWORD(l) ((WORD)(((DWORD_PTR)(l)) & 0xffff))
#define HIWORD(l) ((WORD)((((DWORD_PTR)(l)) >> 16) & 0xffff))
#define UBOUND(T) (T.size())
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16)) 

static wchar_t  *$NULL        = L"";
static wchar_t  *$ZTRACE      = L"zTrace 2.01 ";

const wchar_t   *$COMMA       = L",";
const wchar_t   *$ANTI        = L"\\";
const wchar_t   *$ZLIM        = L"|";

//----------------------------------------------------------------------

const DWORD dwStyle = WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME;
const DWORD dwExStyle = WS_EX_TOOLWINDOW;

const int HORIZONTAL_EXTENT   = 6000; // Maximum value for the horizontal scrollbar
const int MIN_WIDTH           = 300;  // default client width size
const int MIN_HEIGHT          = 65;   // default client height size

const int ID_LISTBOX          = 1;

const int IDM_About           = 101;  // menu popup
const int IDM_Hscroll         = 103;  // menu popup
const int IDM_Print           = 104;  // menu popup
const int IDM_CopyToClipboard = 105;  // menu popup
const int IDM_ClearContent    = 106;  // menu popup
const int IDM_TopMost         = 107;  // menu popup
const int IDM_Debug           = 108;  // menu popup
const int IDM_SaveCoordinates = 109;  // menu popup

long gnX, gnY, gnW, gnH, gbUseTopMost, gbSaveCoordinates, gbDebug, gbScrollBar;
HBRUSH gnBackBrush;

WCHAR g_CAPTION[24];
//----------------------------------------------------------------------

long INSTR(IN long nIndex, IN wstring sMain, IN wstring sSearch) {
    long nRet = -1; // Not found
    long nLength = (long) (sMain.length());
    if (nLength && (sSearch.length())) {
        if (nIndex < 0) {
            nRet = (long) (sMain.rfind(sSearch, nLength + nIndex + 1)); }
        else {
            nRet = (long) (sMain.find(sSearch, nIndex));
        }
    }
    return nRet + 1;
}

wstring zDateTime() { // dllexport
    time_t     now = time(0);
    struct tm  tstruct;
    WCHAR      buf[80];
    if (localtime_s(&tstruct, &now) == 0) {;
        wcsftime(buf, sizeof(buf), L"%Y%m%d,%X", &tstruct);
    }
    return buf;
}

wstring STRL$(IN long N) {
    WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*) longstr;

}

wstring LEFT$(IN wstring sBuf, IN long nLeft) { // dllexport
    wstring sResult = $NULL;
    LONG_PTR nLength = max(min((long)sBuf.length(), nLeft), 0);
    if (nLength) {
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

wstring RTRIM$(IN wstring sBuf, IN wstring sChar) { // dllexport
    wstring sResult = sBuf;
    LONG_PTR nLength = sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        while (nLength > 0) {
            // if (*sBuf.substr(nLength - 1, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::wstring::npos != sChar.find(sBuf.substr(nLength - 1, 1))) {
                --nLength; }
            else {
                break;
            }
        }
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

string rtrim$(IN string sBuf, IN string sChar) { // dllexport
    string sResult = sBuf;
    LONG_PTR nLength = sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        while (nLength > 0) {
            // if (*sBuf.substr(nLength - 1, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::string::npos != sChar.find(sBuf.substr(nLength - 1, 1))) {
                --nLength; }
            else {
                break;
            }
        }
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

wstring MID$(IN wstring sBuf, IN long nStart, IN long nMid = 0) { // dllexport
    wstring sResult = $NULL;
    long nLength = (long) sBuf.length();
    if (nMid == 0) { nMid = nLength - nStart + 1; }
    if (nLength) { sResult = sBuf.substr(nStart - 1, nMid); }
    return sResult;
}

WCHAR* zGetTempPath () {
    static WCHAR buf[MAX_PATH];
    long nSize = GetTempPath(GetTempPath(NULL, NULL), &buf[0]);
    wstring sTempPath = RTRIM$((wstring) buf, $ANTI);
    sTempPath += $ANTI;
    memset(&buf[0], 0, sizeof(buf));
    MoveMemory(&buf[0], (WCHAR*) sTempPath.c_str(), sTempPath.length() * 2);
    return buf;
}

HINSTANCE zInstance () {
    return GetModuleHandle(NULL);
}

wstring zGetTextListbox(IN HWND hListBox, IN long nItem) {
    wstring sResult;
    long nLength = (long) SendMessage(hListBox, LB_GETTEXTLEN, nItem, 0);
    WCHAR* sItem = new WCHAR[(nLength + 1) * sizeof(WCHAR)];
    memset(&sItem[0], 0, (nLength + 1) * sizeof(WCHAR));
    nLength = (long) SendMessage(hListBox, LB_GETTEXT, (WPARAM) nItem, (LPARAM) &sItem[0]);
    sResult = (WCHAR*) sItem;
    delete [] sItem;
    return sResult;
}

string parse$(IN string sMain, IN long nIndex) { 
    string sResult;
    string sDelim = ",";
    long nLength = (long) sDelim.length();
    sMain = rtrim$(sMain, sDelim); sMain += sDelim;
    if (sMain.length() && nLength) {
        size_t prev_pos = 0, pos = 0, nCount = 0;
        while( (pos = sMain.find(sDelim, pos)) != std::string::npos ) {
            string substring(sMain.substr(prev_pos, pos - prev_pos));
            ++nCount;
            if (nCount == nIndex) { sResult = substring; break; }
            prev_pos = ++pos;
        }
    }
    return sResult;
}

string str$(IN long N) {
    char longstr[33] = {0};
    _itoa_s(N, longstr, 10);
    return (char*) longstr;

}

long LongValA(IN string sNum) {
    return atol(sNum.c_str());
}

// Returns current Disk and Path
void zDskPath (OUT wstring &sDsk, OUT wstring &sPath) {
    WCHAR buf[MAX_PATH];
    if (GetCurrentDirectory(MAX_PATH, buf)) {
        sDsk = LEFT$((wstring) buf, 2);
        sPath = RTRIM$(MID$((wstring) buf, 3), $ANTI);
        sPath += $ANTI;
    }
}

// Splits a full path name, and return the current disk and directory
void zSplitN (IN WCHAR* FullName, OUT WCHAR* PathName, OUT WCHAR* FilName) { // dllexport
    wstring sDsk = $NULL, sThisPath = $NULL;
    long So = 0, nLength = 0;
    wstring sFullName = (WCHAR*) FullName;
    wstring sPathName = $NULL;
    wstring sFilName = $NULL;
    // if no path is specified { the current directory is being used.
    sPathName = $NULL; sFilName = $NULL;
    nLength = (long) (sFullName.length());
    if (nLength) {
       zDskPath(sDsk, sThisPath); sFilName = sFullName;
       So = INSTR(-1, sFullName, $ANTI);
       if (So) {
           sPathName = LEFT$(sFullName, So); }
       else {
          So = INSTR(0, sFullName, L":");
       }
       if ((sPathName.c_str() == sDsk.c_str()) || (sPathName.length() == 0)) {
          sPathName = sDsk; sPathName += sThisPath;
       }
       if (So) { sFilName = MID$(sFullName, So + 1, nLength - So); }
    }
    MoveMemory(&PathName[0], (WCHAR*) sPathName.c_str(), sPathName.length() * sizeof(WCHAR));
    MoveMemory(&FilName[0], (WCHAR*) sFilName.c_str(), sFilName.length() * sizeof(WCHAR));
}

// Kill directly a file without sending it to recycle.bin
long zKillFile (IN WCHAR* sFullName) { // dllexport
    long nRet = 0;
    WIN32_FIND_DATA fd = { 0 };
    wstring sPathName, sFilterName, sToKill;
    WCHAR PathName[MAX_PATH] = {0};
    WCHAR FilName[MAX_PATH] = {0};
    zSplitN (sFullName, &PathName[0], &FilName[0]);
    sPathName = &PathName[0];
    sFilterName = &FilName[0];
    fd.dwFileAttributes = 39; // NORMAL + READONLY + HIDDEN + SYSTEM + ARCHIVE
    HANDLE hFind;
    hFind = FindFirstFile(sFullName, &fd);
    if (hFind != INVALID_HANDLE_VALUE) {
       do {
           sToKill = sPathName; sToKill += fd.cFileName;
           SetFileAttributes(sToKill.c_str(), FILE_ATTRIBUTE_NORMAL);
           if (DeleteFile(sToKill.c_str()) == 0) {
               nRet = GetLastError(); break;
           }
       }
       while (FindNextFile(hFind, &fd) != 0);
    }
    return nRet;
}

// Generic open file function
long zFOpen (IN wstring sFilName, IN long AccessMode, IN long ShareMode, OUT HANDLE &hFile) {

    long AccessIs, ShareIs, FlagAndAttribute, nRet;
    nRet = 0; hFile = 0;

    AccessMode = min(max(AccessMode, 0), 2);    // Coherce between 0-2
    if (AccessMode == 0) {                      // 0 Open for read only.
       AccessIs = GENERIC_READ; }
    else if (AccessMode == 1) {                 // 1 Open for write only.
       AccessIs = GENERIC_WRITE; }
    else {                                      // 2 Open for read and write.
       AccessIs = GENERIC_READ | GENERIC_WRITE;
    }

    ShareMode = min(max(ShareMode, 1), 4);      // Coherce between 1-4
    if (ShareMode == 1) {                       // 1 Deny read/write access.
       ShareIs = 0; }
    else if (ShareMode == 2) {                  // 2 Deny write access.
       ShareIs =  FILE_SHARE_READ; }
    else if (ShareMode == 3) {                  // 3 Deny read access.
       ShareIs =  FILE_SHARE_WRITE; }
    else {                                      // 4 Deny none (full share mode).
       ShareIs =  FILE_SHARE_READ | FILE_SHARE_WRITE;
    }

    if (hFile == INVALID_HANDLE_VALUE) {
       FlagAndAttribute = FILE_ATTRIBUTE_NORMAL | FILE_FLAG_WRITE_THROUGH; }
    else {
       FlagAndAttribute = FILE_ATTRIBUTE_NORMAL;
    }

    hFile = CreateFile(sFilName.c_str(), AccessIs, ShareIs, NULL, OPEN_ALWAYS, FlagAndAttribute, NULL);

    if (hFile == INVALID_HANDLE_VALUE) {        // -1 Fail to create the file
       nRet = GetLastError();                   // Set the error code
       hFile = 0;                               // Reset handle number
    }
    return nRet;
}

// Check if disk file exist
BOOL zExist (IN wstring sFileSpec) { // dllexport
    WIN32_FIND_DATA fd = { 0 };
    LPCTSTR lpFileSpec = sFileSpec.c_str();
    BOOL bRet = FALSE;
    if (sFileSpec.length()) {
       HANDLE hFind;
       hFind = FindFirstFile(sFileSpec.c_str(), &fd);
       if (hFind != INVALID_HANDLE_VALUE) {
          FindClose(hFind);
          bRet = TRUE;
       }
    }
    return bRet;
}

DWORD zFlof (IN HANDLE hFile) { // dllexport
    DWORD dwFileSize = 0;
    if (hFile) {
       if (GetFileType(hFile) == FILE_TYPE_DISK) {
           dwFileSize = GetFileSize(hFile, NULL);
           if (dwFileSize == INVALID_FILE_SIZE) { dwFileSize = 0; } // Error
       }
    }
    return dwFileSize;
}

long zFPut (IN HANDLE hFile, IN string sBuffer) {
    long nRet = 0;
    if (hFile) {
       DWORD ByttesWritten = 0;
       DWORD LenBuf = (DWORD) (sBuffer.length());
       if (LenBuf) {
          if (WriteFile(hFile, (CHAR*) sBuffer.c_str(), LenBuf, &ByttesWritten, NULL) == 0) {
             nRet = GetLastError();
          }
       }
    }
    return nRet;
}

long zFGet (IN HANDLE hFile, OUT string &sBuffer) { // dllexport
    long nRet = 0;
    if (hFile) {
       DWORD ByttesReaded = 0;
       DWORD LenBuf = (DWORD) (sBuffer.length());
       if (LenBuf) {
          if (ReadFile(hFile, (CHAR*) sBuffer.c_str(), LenBuf, &ByttesReaded, NULL) == 0) {
              nRet = GetLastError();
          }
       }
    }
    return nRet;
}

void zFClose (OUT HANDLE &hFile) { // dllexport
    if (hFile) { CloseHandle(hFile); }
    hFile = NULL;
}

void zLoadSaveCoordinates (OUT long &x, OUT long &y, OUT long &w, OUT long &h, IN long RW) {
    HANDLE hFile;
    static WCHAR buffer[512];
    static string WasCoordinates;

    wstring sFileName = zGetTempPath(); sFileName += L"zTrace.cfg";
    if (RW) {
       string sLim = ",";
       WasCoordinates =  str$(x);                 WasCoordinates += sLim;
       WasCoordinates += str$(y);                 WasCoordinates += sLim;
       WasCoordinates += str$(w);                 WasCoordinates += sLim;
       WasCoordinates += str$(h);                 WasCoordinates += sLim;
       WasCoordinates += str$(gbUseTopMost);      WasCoordinates += sLim;
       WasCoordinates += str$(gbSaveCoordinates); WasCoordinates += sLim;
       WasCoordinates += str$(gbScrollBar);       WasCoordinates += sLim;
       WasCoordinates += str$(gbDebug);
       memset(&buffer[0], 0, sizeof(buffer));
       MoveMemory(&buffer[0], (WCHAR*) WasCoordinates.c_str(), WasCoordinates.length() * 2);
       zKillFile((WCHAR*) sFileName.c_str());
       if (zFOpen(sFileName, 1, 1, hFile) == 0) {
          zFPut(hFile, (char*) WasCoordinates.c_str());
          zFClose(hFile); }
       }
    else {
       if (WasCoordinates.length() == 0) {
          if (zExist((WCHAR*) sFileName.c_str())) {
             if (zFOpen(sFileName, 0, 0, hFile) == 0) {
                WasCoordinates.assign(zFlof(hFile), 32);
                zFGet(hFile, WasCoordinates);
                zFClose(hFile);
             }
          }
          x = LongValA(parse$(WasCoordinates, 1));
          y = LongValA(parse$(WasCoordinates, 2));
          w = LongValA(parse$(WasCoordinates, 3));
          h = LongValA(parse$(WasCoordinates, 4));
          gbUseTopMost       = LongValA(parse$(WasCoordinates, 5));
          gbSaveCoordinates  = LongValA(parse$(WasCoordinates, 6)); if (gbSaveCoordinates == 0) { w = 0; }
          gbScrollBar        = LongValA(parse$(WasCoordinates, 7));
          gbDebug            = LongValA(parse$(WasCoordinates, 8));
       }
       if ((w == 0) || (h == 0)) { w = MIN_WIDTH; h = MIN_HEIGHT; x = 0; y = 0; }
    }
}

long WstringToChar(IN wstring sTxt, OUT char* szTxt) {
    size_t convertedChars = 0; 
    wcstombs_s(&convertedChars, szTxt, sTxt.length() + 1, sTxt.c_str(), _TRUNCATE);
    return (long) max(convertedChars - 1, 0);
}

// Copy any debug string to a sequential ASCII file.
void zDebug (WCHAR* zMessage) {
    static HANDLE hDebug;
    static long NeverBeenThere;
    wstring sMessage;
    long nLen = (long) wcslen(zMessage);
    if (hDebug && (nLen == 0)) {
       zFClose(hDebug);
       NeverBeenThere = 0;
       return;
    }
    if (nLen) {
       if (NeverBeenThere == 0) {
          NeverBeenThere = -1;
          wstring sFileName = L"zDebug.txt";
          zKillFile((WCHAR*) sFileName.c_str());
          zFOpen(sFileName, 2, 4, hDebug);
       }
       sMessage = (WCHAR*) zMessage; sMessage += L"\r\n";
       char* buffer = new char[sMessage.length() + 1];
       WstringToChar(sMessage, buffer);
       zFPut(hDebug, (char*) buffer);
       delete [] buffer;
    }
}

void SendUnicodeToClipboard (IN HWND hWnd) {
    HWND hCtrl = GetDlgItem(hWnd, ID_LISTBOX);
    long nCount = (long) SendMessage(hCtrl, LB_GETCOUNT, 0, 0);
    if (nCount > 0) {
       long nSelItems = (long) SendMessage(hCtrl, LB_GETSELCOUNT, 0, 0);
       wstring sBuffer = $NULL;
       long K;
       if (nSelItems > 0) {
          long* SelItem = new long[nSelItems];
          nCount = (long) SendMessage(hCtrl, LB_GETSELITEMS, nSelItems, (LPARAM) &SelItem[0]);
          for (K = 0; K < nSelItems; ++K) {
              nCount = SelItem[K];
              sBuffer +=  zGetTextListbox(hCtrl, SelItem[K]); sBuffer += L"\r\n";
          }
          delete [] SelItem; }
       else {
          for (K = 0; K < nCount; ++K) {
              sBuffer += zGetTextListbox(hCtrl, K); sBuffer += L"\n";
          }
       }
       nCount = (long) sBuffer.length() + 1;
       WCHAR* buffer = new WCHAR[nCount];
       memset(&buffer[0], 0, nCount * sizeof(WCHAR)); // I like to clear the new memory buffer with NULLs
       MoveMemory(&buffer[0], (WCHAR*) sBuffer.c_str(), nCount * sizeof(WCHAR));
       HGLOBAL hClipData = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, nCount * sizeof(WCHAR));
       LPVOID hGlob = GlobalLock(hClipData);
       MoveMemory(hGlob, &buffer[0], nCount * sizeof(WCHAR));
       GlobalUnlock(hClipData);
       if (OpenClipboard(0)) {
          EmptyClipboard();
          SetClipboardData(CF_UNICODETEXT, hClipData);
          CloseClipboard(); }
       else {
          GlobalFree(hClipData);
       }
       delete [] buffer;
    }
}

LRESULT CALLBACK ToolProc (IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    RECT rc, rw;
    long K = 0, nCount = 0, nSelItems = 0;
    HWND hCtrl = 0;
    wstring sMessage;
    MINMAXINFO pMM = {0};
    PRINTDLG pd = {0};
    DOCINFO di = {0};
    TEXTMETRIC tm = {0};
    long yChar, nLinesPerPage, nCharsPerLine;

    long wP = LOWORD(wParam);

    switch (uMsg) {

    case WM_CREATE:
         if (gnBackBrush == 0) { gnBackBrush = CreateSolidBrush(0x00FFFF); }
         break;

    case WM_GETMINMAXINFO:
         MoveMemory(&pMM, (MINMAXINFO*) lParam, sizeof(pMM));
         SetRect(&rc, 0, 0, MIN_WIDTH, MIN_HEIGHT);
         AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle);  // Adjust Window To True Requested Size
         pMM.ptMinTrackSize.x = rc.right;
         pMM.ptMinTrackSize.y = rc.bottom;
         break;

    case WM_COMMAND:

         switch (wP) {
         case IDCANCEL:
              if (HIWORD(wParam) == BN_CLICKED) {
                 SendMessage(hWnd, WM_DESTROY, wParam, lParam);
                 return 0;
              }
              break;

         case IDM_About:
              sMessage = L"           Debugging window\n\nCopyright  ";
              sMessage += LEFT$(zDateTime(), 4);
              sMessage +=        L" Patrice TERRIER  " 
                                 L"\n       pterrier@zapsolution.com"
                                 L"\n\n          www.zapsolution.com";
              MessageBox(0, (WCHAR*) sMessage.c_str(), g_CAPTION, MB_OK);
              break;  
         
         case IDM_Hscroll:
              hCtrl = GetDlgItem(hWnd, ID_LISTBOX);
              gbScrollBar = !gbScrollBar;
              if (gbScrollBar) {
                 ShowScrollBar(hCtrl, SB_HORZ, TRUE);
                 SendMessage(hCtrl, LB_SETHORIZONTALEXTENT, HORIZONTAL_EXTENT, 0); }
              else {
                 SendMessage(hCtrl, LB_SETHORIZONTALEXTENT, 1, 0);
                 ShowScrollBar(hCtrl, SB_HORZ, FALSE);
              }
              UpdateWindow(hCtrl);
              break;
         
         case IDM_Print:
              hCtrl = GetDlgItem(hWnd, ID_LISTBOX);
              nCount = (long) SendMessage(hCtrl, LB_GETCOUNT, 0, 0);
              if (nCount > 0) {
                  PRINTDLG pd = {0};
                  pd.lStructSize = sizeof(pd);
                  // get rid of PD_RETURNDEFAULT on the line below if you'd like to
                  // see the "Printer Settings" dialog!
                  pd.Flags = PD_RETURNDEFAULT | PD_RETURNDC;
                  if (PrintDlg(&pd)) {
                      HDC hPrinter = pd.hDC;
                      GetTextMetrics(pd.hDC, &tm);

                      yChar = tm.tmHeight + tm.tmExternalLeading;
                      nLinesPerPage = GetDeviceCaps(pd.hDC, VERTRES) / yChar;
                      nCharsPerLine = GetDeviceCaps(pd.hDC, HORZRES) / tm.tmAveCharWidth;
                  
                      di.cbSize = sizeof(di);
                      StartDoc(hPrinter, &di);
                          StartPage(hPrinter);
                              nSelItems = (long) SendMessage(hCtrl, LB_GETSELCOUNT, 0, 0);
                              if (nSelItems > 0) {
                                  long* SelItem = new long[nSelItems];
                                  nCount = (long) SendMessage(hCtrl, LB_GETSELITEMS, nSelItems, (LPARAM) &SelItem[0]);
                                  for (K = 0; K < nSelItems; K++) {
                                       sMessage = zGetTextListbox(hCtrl, SelItem[K]);
                                       TextOut(pd.hDC, 0, (yChar * K), (WCHAR*) sMessage.c_str(), (long) sMessage.length());
                                  } }
                              else {
                                  for (K = 0; K < nCount; K++) {
                                       sMessage = zGetTextListbox(hCtrl, K);
                                       TextOut(pd.hDC, 0, (yChar * K), (WCHAR*) sMessage.c_str(), (long) sMessage.length());
                                  }
                              }
                          EndPage(hPrinter);
                      EndDoc(hPrinter);
                      DeleteDC(hPrinter);
                  }
              }
              break;
         
         case IDM_CopyToClipboard:
              SendUnicodeToClipboard(hWnd);
              break;
         
         case IDM_ClearContent:
              SendMessage(GetDlgItem(hWnd, ID_LISTBOX), LB_RESETCONTENT, 0, 0);
              break;
         
         case IDM_TopMost:
              gbUseTopMost = !gbUseTopMost;
              if (gbUseTopMost) {
                 SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW); }
              else {
                 SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW);
              }
              break;
         
         case IDM_Debug:
              gbDebug = !gbDebug ;
              if (gbDebug) {
                 hCtrl = GetDlgItem(hWnd, ID_LISTBOX);
                 nCount = (long) SendMessage(hCtrl, LB_GETCOUNT, 0, 0)   ;
                 if (nCount > 0) {
                    for (K = 0; K < nCount; ++K) {
                        zDebug((WCHAR*) zGetTextListbox(hCtrl, K).c_str());
                    }
                 }
              else {
                 zDebug($NULL); // Close zDebug.txt if already open.
              }
              break;
         
         case IDM_SaveCoordinates:
              gbSaveCoordinates = !gbSaveCoordinates;
              break; }
         }
         break;

    case WM_CTLCOLORDLG:
         SetBkColor((HDC) wParam, GetSysColor(COLOR_WINDOW));
         return (LRESULT) GetStockObject(NULL_BRUSH);

    case WM_CTLCOLORBTN:
    case WM_CTLCOLOREDIT:
    case WM_CTLCOLORLISTBOX:
    case WM_CTLCOLORSTATIC:
         // wParam is handle of control's display context (hDC)
         // lParam is handle of control
         //------------------------------------------------------
         if (lParam == (LPARAM) GetDlgItem(hWnd, ID_LISTBOX)) {
            SetBkColor((HDC) wParam, 0x00FFFF);
            return (LRESULT) gnBackBrush;
         }
         break;

    case WM_RBUTTONDOWN:
         HMENU hMenu; POINT p;
         long menuStyle, nChoice;
         hMenu = CreatePopupMenu();
         if (hMenu) {
            AppendMenu(hMenu, MF_STRING, IDM_About            , L"About");
            AppendMenu(hMenu, MF_SEPARATOR, 102               , L"");
            if (gbScrollBar) { menuStyle = MF_STRING | MF_CHECKED; } else { menuStyle = MF_STRING; }
            AppendMenu(hMenu, menuStyle,  IDM_Hscroll         , L"Use horizontal scrollbar");
            AppendMenu(hMenu, MF_STRING,  IDM_Print           , L"Send selection to printer");
            AppendMenu(hMenu, MF_STRING,  IDM_CopyToClipboard , L"Copy selection to clipboard");
            AppendMenu(hMenu, MF_STRING,  IDM_ClearContent    , L"Clear content");
            if (gbUseTopMost) { menuStyle = MF_STRING | MF_CHECKED; } else { menuStyle = MF_STRING; }
            AppendMenu(hMenu, menuStyle,  IDM_TopMost         , L"Set window TopMost");
            if (gbDebug) { menuStyle = MF_STRING | MF_CHECKED; } else { menuStyle = MF_STRING; }
            AppendMenu(hMenu, menuStyle,  IDM_Debug           , L"Create zDebug.txt report");
            if (gbSaveCoordinates) { menuStyle = MF_STRING | MF_CHECKED; } else { menuStyle = MF_STRING; }
            AppendMenu(hMenu, menuStyle,  IDM_SaveCoordinates , L"Save window coordinates");

            GetCursorPos(&p);
            nChoice = TrackPopupMenuEx(hMenu, TPM_RETURNCMD, p.x, p.y, hWnd, NULL);
            DestroyMenu(hMenu);
            if (nChoice) { SendMessage(hWnd, WM_COMMAND, MAKLNG(nChoice, 0), 0); }
         }
         break;

    case WM_MOVE:
         GetWindowRect(hWnd, &rw); gnX = rw.left; gnY = rw.top;
         break;

    case WM_SIZE:
         if (wParam != SIZE_MINIMIZED) {
            gnW = LOWORD(lParam); gnH = HIWORD(lParam);
            MoveWindow(GetDlgItem(hWnd, ID_LISTBOX), 0, 0, gnW, gnH, TRUE);
            UpdateWindow(hWnd);

            GetWindowRect(hWnd, &rw); gnX = rw.left; gnY = rw.top;

         }
         break;

    case WM_DESTROY:
         if (gnBackBrush) {
            DeleteObject(gnBackBrush); gnBackBrush = 0;
            GetWindowRect(hWnd, &rw);
            GetClientRect(hWnd, &rc);
            zLoadSaveCoordinates (rw.left, rw.top, rc.right, rc.bottom, 1);
         }

         PostQuitMessage(0);
         return 0;

    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

long AddString(IN HWND hCtrl, WCHAR* zPtr) {
    long nRet;
    if (gbDebug) {
       if (zPtr) { zDebug(zPtr); }
    }
    nRet = (long) SendMessage(hCtrl, LB_ADDSTRING, 0, (LPARAM) zPtr);

    SendMessage(hCtrl, LB_SETTOPINDEX, (WPARAM) nRet, 0);

    return nRet;
}

DWORD WINAPI ShowPopup (IN WCHAR* zPtr) {
    DWORD nRet = 0;
    MSG msg;
    long IsInitialized;
    HWND hWnd, hCtrl;

    WNDCLASSEX wcx;
    RECT rc;

    wstring sCaption = $ZTRACE; sCaption += STRL$(sizeof(LONG_PTR) * 8); sCaption += L"-bit";
    MoveMemory(&g_CAPTION[0], (WCHAR*) sCaption.c_str(), sCaption.length() * 2);

    wcx.cbSize = sizeof(wcx);
    IsInitialized = GetClassInfoEx(zInstance(), g_CAPTION, &wcx);
    if (IsInitialized    == 0) {
       wcx.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
       wcx.lpfnWndProc   = &ToolProc;
       wcx.cbClsExtra    = 0;
       wcx.cbWndExtra    = 0;
       wcx.hInstance     = zInstance();
       wcx.hIcon         = 0;
       wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
       wcx.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
       wcx.lpszMenuName  = NULL;
       wcx.lpszClassName = g_CAPTION;
       wcx.hIconSm       = wcx.hIcon;
       if (RegisterClassEx(&wcx)) { IsInitialized = TRUE; }
    }

    if (IsInitialized) {
       long UseX = 0, UseY = 0, UseW = 0, UseH = 0;
       zLoadSaveCoordinates (UseX, UseY, UseW, UseH, 0);

       SetRect(&rc, 0, 0, UseW, UseH);
       AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle);  // Adjust Window To True Requested Size

       hWnd = CreateWindowEx(dwExStyle, g_CAPTION, g_CAPTION,
                             dwStyle,
                             UseX, UseY,
                             rc.right - rc.left,  // Calculate Window Width
                             rc.bottom - rc.top,  // Calculate Window Height
                             0, 0, zInstance(), NULL);
       if (hWnd) {
          DWORD nStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | LBS_MULTIPLESEL | LBS_HASSTRINGS | LBS_NOINTEGRALHEIGHT | LBS_EXTENDEDSEL | LBS_DISABLENOSCROLL;
          hCtrl = CreateWindowEx(0, L"ListBox", NULL, nStyle, 0, 0, UseW, UseH, hWnd, (HMENU) ID_LISTBOX, zInstance(), NULL);
          SendMessage(hCtrl, WM_SETFONT, (WPARAM) GetStockObject(ANSI_FIXED_FONT), 0);
          AddString(hCtrl, zPtr);
          if (gbScrollBar) {
             SendMessage(hCtrl, LB_SETHORIZONTALEXTENT, HORIZONTAL_EXTENT, 0);
             ShowScrollBar(hCtrl, SB_HORZ, TRUE); }
          else {
             ShowScrollBar(hCtrl, SB_HORZ, FALSE);
          }

          if (gbUseTopMost) {
             SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_SHOWWINDOW); }
          else {
             ShowWindow(hWnd, SW_SHOW);
          }
          UpdateWindow(hWnd);

          while (GetMessage(&msg, NULL, 0, 0)) {
             // Easier to detect the right mouse button click on the listBox from the message pump
             if ((msg.hwnd == hCtrl) && (msg.message == WM_RBUTTONDOWN)) {
                ToolProc(hWnd, WM_RBUTTONDOWN, 0, 0); }
             else {
                if (IsDialogMessage(hWnd, &msg) == FALSE ){
                   TranslateMessage(&msg);
                   DispatchMessage(&msg);
                }
             }
          }
          nRet = (DWORD) msg.wParam;
       }
    }
    return nRet;
}

ExportC long zTrace (IN WCHAR* zPtr) {
    long nRet = 0;
    HWND hWnd = FindWindow(g_CAPTION, g_CAPTION);
    if (hWnd == 0) {
       nRet = LB_ERR;
       DWORD dwThreadId = 0;
       HANDLE hThread = CreateThread(NULL,                                  // default security attributes
                                     0,                                     // use default stack size  
                                     (LPTHREAD_START_ROUTINE ) ShowPopup,   // thread function name
                                     zPtr,                                  // argument to thread function 
                                     0,                                     // use default creation flags 
                                     &dwThreadId);                          // returns the thread identifier
       if (hThread) {
           nRet = 0;
           Sleep(100); }
           CloseHandle(hThread);
       }
    else {
       if (wcslen(zPtr)) { nRet = AddString(GetDlgItem(hWnd, ID_LISTBOX), zPtr); }
    }
    return nRet;
}

BOOL WINAPI DllMain(IN HINSTANCE hDllHandle, IN DWORD nReason, IN LPVOID Reserved) {
    BOOL bRet = TRUE;
    if (nReason == DLL_PROCESS_DETACH) {
       if (gnBackBrush) {
          DeleteObject(gnBackBrush); gnBackBrush = 0;
          zLoadSaveCoordinates (gnX, gnY, gnW, gnH, 1);
       }
       zDebug($NULL);
    }
    return bRet;
}
